-- experiment:
-- what if I have the server use a sayto to send state that's difficult to sync. netvars
-- is only called once, but would be SO MUCH BETTER if it could sync every time

-- server side
local function cgs_sendState(key,value)
    if not isserver then return end
    for i=1,(#players-1) do 
        if players[i] == nil then continue end
        COM_BufInsertText(server,"sayto "..i.." cgsync:"..key..":"..value)
    end
end

rawset(_G,"cgs_sendState", cgs_sendState)

-- notify cgsync to sync this variable
local cgs_registers = {}
rawset(_G,"cgs_registers", cgs_registers)
local function cgs_registerState(variable,name)
    if type(variable) != "table" then
        error(name.." was passed into cgsync:registerState, but wasn't a table (needs to be a table)")
        return
    end
    if variable.value == nil then
        error(name.." needs to have key 'value' populated in order to work with cgs_registerState")
        return
    end
    cgs_registers[name] = variable
end
rawset(_G,"cgs_registerState", cgs_registerState)

local function cgs_get(key)
    if cgs_registers[key] == nil then
        return nil
    end

    return cgs_registers[key].value
end
rawset(_G,"cgs_get", cgs_get)


addHook("PlayerMsg", function(source, msgtype, target, msg)
    local isACgSyncMsg = (msg:sub(1, 7) != "cgsync:")
    local isTo = msgtype == 5 -- the To msg for the sender of a PM
    if isTo and isserver and not isdedicatedserver and isACgSyncMsg then 
        -- Hide CG Sync for the server player
        return true
    end
	if msgtype != 2 then return end -- must be sayto
    if source != server then return end
	if isACgSyncMsg then return end


    local data = pipesplit(msg,":")
    local key, newvalue = data[2], data[3]
    cgs_registers[key].value = newvalue
    return true
end)

local function netvars(net)
    cgs_registers = net($)
end
addHook("NetVars", netvars)

-- JUGGYYY!! this is so jank but it's how I can hide messages from the server when JJT is loaded
-- sorry, messages from the server now cannot be muted. I can't imagine a server owner
-- would legitamitely want to let players mute the server or admins
local jjt_patched = false

addHook("ThinkFrame",function()
    if juggy != nil and not jjt_patched then
        -- force JJT settings to allow users to mute server node
        if isserver then 
            COM_BufInsertText(server,"jug_mute_enabled On")
            COM_BufInsertText(server,"jug_mute_immunity Off")
        end
        
        -- If we're a dedicated, we're done
        if isdedicatedserver then
            print("CG Sync: Detected Juggys Jug of Tools. Adding patch for interop..")
            jjt_patched = true
            return
        end

        -- stop here if a player exists, and consoleplayer isn't loaded yet..
        if not isserver and consoleplayer == nil then return end

        -- now acutally trick JJT to stop displaying messages from server node
        print("CG Sync: Detected Juggys Jug of Tools. Adding patch for interop..")

        jjt_patched = true

        -- He thought of everything... Adding a module which will tell JJT to not show PMs from the server
        local function dontShowTo(params)
            local isTo = params.msgtype == juggy.chatType.SayTo -- shouldn't it be chatType.To (5)?
            local msg = params.message
            local isACgSyncMsg = (msg:sub(1, 7) == "cgsync:")
            -- if isTo and isserver and not isdedicatedserver and isACgSyncMsg then
            if isTo and not isdedicatedserver and isACgSyncMsg then
                params.returntype = true
            end
            return params
        end

        -- Module that will prevent user commands such as !nvhelp and !nvclockhelp from appearing
        -- this should be in the main lua, but I don't want to introduce another ThinkFrame
        local function dontShowUserCmds(params)
            local isSay = params.msgtype == juggy.chatType.Say
            local msg = params.message
            local isNvCommand = msg:inTable({"!nvhelp", "!nvclockhelp"})
            local isBallotCast = msg:inTable({"1", "2", "3", "4"}) and (get_nv_state() == NV_CHOICE)
            nvdbp("isSay",isSay,"msgtype",params.msgtype,"msg",msg,"iscmd",isNvCommand,"isballot",isBallotCast,"full logic",isSay and (isNvCommand or isBallotCast))
            if isSay and (isNvCommand or isBallotCast) then
                nvdbp("we're returning true agin")
                params.returntype = true
            end
            nvdbp("returning",params.returntype)
            return params
        end
        juggy.createChatModule(dontShowTo,juggy.CHATMOD_INTEROP)
        juggy.createChatModule(dontShowUserCmds,juggy.CHATMOD_INTEROP)

        -- fun note: I used to just reimplement juggy's code here while muting his stuff. It was nutz.
        -- moral of the story - check the code if you can get around crazy solutions
    end
end)

